/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING 
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT 
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR 
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE 
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software 
* and to discontinue the availability of this software.  By using this software, 
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2010, 2011 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : Applilet3 for RL78/G13 V1.03.01 [11 Oct 2011]
* Device(s)    : R5F1016A
* Tool-Chain   : IAR Systems iccrl78
* Description  : This file implements main function.
* Creation Date: 27.08.2012
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_adc.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"


#include "c:\projekte\renesas_iar\cc_aug12\rea10_347\user_src\bosch.h"
#include "c:\projekte\renesas_iar\cc_aug12\rea10_347\user_src\i2c.h"
#include "c:\projekte\renesas_iar\cc_aug12\rea10_347\user_src\gps.h"
#include <stdlib.h>

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Set option bytes */
#pragma location = "OPTBYTE"
__root const uint8_t opbyte0 = 0xEFU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte1 = 0x1FU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte2 = 0xADU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte3 = 0x84U;

/* Set security ID */
#pragma location = "SECUID"
__root const uint8_t secuid[10] = 
    {0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */


#if 0
/**************************************************************************
 *                                                                        *
 *  Name:        CALC - Algorithmen                                       *
 *  Description: diverse Berechnungs- und Filterroutinen                  *
 *                                                                        *
 *                                                                        *
 *  Date  :      07.06.2009                                               *
 *  Author:      J. 
 *  Revision List:
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  07.06.09 |Dr J.   | Ersterstellung
  -------------------------------------------------------------------------
           |                 |
  --------------------------------------------------------------------------
 **************************************************************************/
#include "pilot.h"
#include "calc.h"
#include "aone.h"
#include "ocrtl.h"
#include "sio.h"
#include "sim.h"

/**************************************************************************
* Variablen 
***************************************************************************/
word wRollLp; /*
* Description : 
*/

word wRollFixLp; /*
* Description : Vergleichswert fr Roll-Gyro
*/

word wNickLp; /*
* Description : gefilterter Sensorwert
*/

word wNickFixLp; /*
* Description : 
*/

int16 iRollJoy; /*
* Description : Joystickwert fr Rollwinkel
*/

int16 iNickJoy; /*
* Description : dito
*/

int16 iYawJoy; /*
* Description : dito. dito.
*/

int16 iEngJoy; /*
* Description : Maschine
*/

word wDirection; /*
* Description : Flugrichtung in Grad
*/

int16 iDirLastDiff; /*
* Description : Richtungsdifferenz bei der vorherigen Messung 
*/

int16 iDirCrtl; /*
* Description : Richtungsparameter 
*/

word wAltitude; /*
* Description : Flughhe in Meter
*/

int16 iAltLastDiff; /*
* Description : Richtungsdifferenz bei der vorherigen Messung 
*/

int16 iAltCrtl; /*
* Description : Richtungsparameter 
*/

word wMinSpeed; /*
* Description : minimale Luftgeschwindigkeit 
*/

word wTripSpeed; /*
* Description : Reisegeschwindigkeit 
*/

int16 iEngCrtl; /*
* Description : Engine
*/

byte bFlag; /*
* Description : Warnflags diverser Flugzustnde
*/

/**************************************************************************
* CODE Section 
***************************************************************************/
#define nLowSpeed     0x01    /* Geschwindigkeit unter Minimum */
#define nLowAlt       0x02    /* Hhe unter Minimum */
#define nEngineOff    0x04    /* Maschine STOP */

#define nLowAltValue  20      /* Schwellwert fr Niedrigflughhe in Meter */


/*****************************************************************************
    Name:           PILOT_vInit()
    Parameters:     nothing
    Returns:        nothing
    Description:    initialise software modul
******************************************************************************/
void PILOT_vInit( void ){
    iDirLastDiff = 0;
    iAltLastDiff = 0;
    }


/*****************************************************************************
    Name:           PILOT_vSetRollNick()
    Parameters:     Vorgabewerte vom Joystick
    Returns:        nothing
    Description:    initialise software modul
******************************************************************************/
void PILOT_vSetRollNick( int16 iRoll, int16 iNick, int16 iYaw, int16 iEng ){
    iRollJoy = iRoll;
    iNickJoy = iNick;
    iYawJoy  = iYaw;
    iEngJoy  = iEng;
    }

/*************************************************************************
    Name:           PILOT_vEngCrtl()
    Parameters:     nothing
    Returns:        nothing
    Description:    Geschwindigkeits- /Maschinenkontrolle
 *************************************************************************/
void PILOT_vEngCrtl( cbyte cID ){
    word w;
    int16 i;
    /* Hhenmessung */
    w = (word)(SIO_i32GetData(FC_ALTITUDE) / 10);
    i = wAltitude - w;            /* Abweichung der Sollhhe bestimmen */
    i = CALC_iLimit( i, -40, 40 );/* Hhentoleranz 20 m */
    iEngCrtl = (i * 20);          /* -800 ... 800 Servowerte */
    iEngCrtl = CALC_iLimit( iEngCrtl, -800, 800 );
    if(bFlag & nEngineOff){       /* Maschine STOP */
        iEngCrtl = -800; 
        }
    }


/*************************************************************************
    Name:           PILOT_vAltCrtl()
    Parameters:     nothing
    Returns:        nothing
    Description:    Flughhenberwachung/Kontrolle
 *************************************************************************/
void PILOT_vAltCrtl( cbyte cID ){
    word wAlt;
    int16 i;
    /* Hhenmessung */
    wAlt = (word)(SIO_i32GetData(FC_ALTITUDE) / 10);
    if(wAlt < nLowAltValue) bFlag |=  nLowAlt;  /* low altitude warning */
    else                    bFlag &= ~nLowAlt;  
    i = wAlt - wAltitude;
    iAltCrtl = 0;
    if(abs(i) > abs(iAltLastDiff)){             /* Fehler wachsend */
        if(i < 0){                              /* hher */
            iAltCrtl =  200;
            }
        if(i > 0){                              /* tiefer */
            iAltCrtl = -200;
            }
        }
    iAltLastDiff = i;
    if(bFlag & nLowAlt){ 
        iAltCrtl = 0;                           /* Hhenruder bleibt neutral */
        }
    }


/*************************************************************************
    Name:           PILOT_vDirCrtl()
    Parameters:     nothing
    Returns:        nothing
    Description:    Flugrichtungsberwachung/Kontrolle
 *************************************************************************/
void PILOT_vDirCrtl( cbyte cID ){
    word wDir;
    int16 i;
    /* Ist-Richtung ermitteln */
    wDir = (word)(SIO_i32GetData(FC_HEADING_DEG) / 10);  
    i = (int16)(wDir - wDirection); /* Abweichung IST - SOLL */
    if(i <= -180) i = i + 360;      /* kleineren Winkel zwischen IST und SOLL bestimmen */
    if(i >=  180) i = 360 - i;
    iDirCrtl = 0;                   /* Offsetwert zunchst := 0 */
    /* steuern nach 1. Ableitung */
    if(abs(i) > abs(iDirLastDiff)){ /* Abweichung zw. IST/SOLL ist gewachsen */
        if(i > 0){                  /* links drehen */
            iDirCrtl = -150;
            }
        if(i < 0){                  /* rechts drehen */
            iDirCrtl =  150;
            }
        }
    iDirLastDiff = i;
    }

#endif
/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/**************************************************************************
* defines, typedefs 
***************************************************************************/
typedef struct CALC_stExpo{
    word wTable;  /* Grenzwert */
    int16 iA;     /* a */
    int16 iB;     /* b */
    } CALC_stExpo;

/**************************************************************************
* Variablen 
***************************************************************************/
word wRollLp; /*
* Description : 
*/

word wRollFixLp; /*
* Description : Vergleichswert fr Roll-Gyro
*/

word wNickLp; /*
* Description : gefilterter Sensorwert
*/

word wNickFixLp; /*
* Description : 
*/

int16 iRollJoy; /*
* Description : Joystickwert fr Rollwinkel
*/

int16 iNickJoy; /*
* Description : dito
*/

int16 iYawJoy; /*
* Description : dito. dito.
*/

int16 iEngJoy; /*
* Description : Maschine
*/

word wDirection; /*
* Description : Flugrichtung in Grad
*/

int16 iDirLastDiff; /*
* Description : Richtungsdifferenz bei der vorherigen Messung 
*/

int16 iDirCrtl; /*
* Description : Richtungsparameter 
*/

word wAltitude; /*
* Description : Flughhe in Meter
*/

int16 iAltLastDiff; /*
* Description : Richtungsdifferenz bei der vorherigen Messung 
*/

int16 iAltCrtl; /*
* Description : Richtungsparameter 
*/

word wMinSpeed; /*
* Description : minimale Luftgeschwindigkeit 
*/

word wTripSpeed; /*
* Description : Reisegeschwindigkeit 
*/

int16 iEngCrtl; /*
* Description : Engine
*/

byte bFlag; /*
* Description : Warnflags diverser Flugzustnde
*/

word awAdcValue[4];
byte bTastFlag = 0;

/**************************************************************************
* Variablen 
***************************************************************************/
int32 iNickBuflp[32]; /*
* Description : 32 loactions for circular bufferin
*/

byte bNickOffsetlp; /*
* Description : Index auf Ringbuffer
*/

int32 iRollBuflp[32]; /*
* Description : 32 loactions for circular bufferin
*/

byte bRollOffsetlp; /*
* Description : Index auf Ringbuffer
*/

/**************************************************************************
* CODE Section 
***************************************************************************/
const int32 iCoeffslp[9] = {
    //-8420, -106, 1604, 4284, 7614, 11064, 14067, 16109, 16837  // 3 Hz - 50 Hz Sample (>>16)
    -131,-360,-533,-277,789,2753,5181,7219,8017 //4/10/2/60 (>> 15)
    //-59,-308,-744,-1020,-427,1582,4722,7694,8921 //4/12/2/60
    };

#define nExpoTableSize  3
#define nExpoRatio      2   /* kleinstes gemeinsames Vielfache */
/* Tabelle zum approximieren der Exponentialfunktion */
const CALC_stExpo abExpoTable[nExpoTableSize] = 
      { 500,  1,     0  /* Grenzwert 375, a = 1/2 (1/nExpoRatio), b = 0 */
      , 750,  2,  -250
      ,1000,  4,  -500 };




/*****************************************************************************
    Name:           OCRTL_wSetServoCrtl( )
    Parameters:     Servowerte als vorzeichenbehaftete Zahlen -100 ... 100
    Returns:        value
    Description:    rechnet die symbolischen Werte in Stellsignale um
******************************************************************************/
void OCRTL_vSetServoCrtl(int16 iS1, int16 iS2,int16 iS3,int16 iS4 ){
    iS1 = (abs(iS1) > 1000) ? 0 : iS1;        /* Begrenzung der Werte */
    iS2 = (abs(iS2) > 1000) ? 0 : iS2;
    iS3 = (abs(iS3) > 1000) ? 0 : iS3;
    iS4 = (abs(iS4) > 1000) ? 0 : iS4;
    //awChannelValue[0] = nNullServoTime + iS1; /* Nick */
    //awChannelValue[1] = nNullServoTime + iS2; /* Roll */ 
    //awChannelValue[2] = nNullServoTime + iS3; /* Engine */
    //awChannelValue[3] = nNullServoTime + iS4; /* Yaw */
    R_TAU0_Channel1_Start();
    }

/*************************************************************************
    Name:           CALC_vNickLp()
    Parameters:     ADC-Wert
    Returns:        gefilterter Wert
    Description:    Tiefpassfilter
 *************************************************************************/
word CALC_NickLp( word bSample ){
    int32 z;
    byte i;
    iNickBuflp[bNickOffsetlp] = bSample;
    z  = (int32)(iCoeffslp[8] * iNickBuflp[(bNickOffsetlp - 8) & 0x1F]);
    for (i = 0;  i < 8;  i++){
        z += (int32)(iCoeffslp[i] * (iNickBuflp[(bNickOffsetlp - i) & 0x1F] + iNickBuflp[(bNickOffsetlp - 16 + i) & 0x1F]));
        }
    bNickOffsetlp = (bNickOffsetlp + 1) & 0x1F;
    return (word)(z >> 15);                                         // Return filter output
    }

/*************************************************************************
    Name:           CALC_vRollLp()
    Parameters:     ADC-Wert
    Returns:        gefilterter Wert
    Description:    Tiefpassfilter
 *************************************************************************/
word CALC_RollLp( word bSample ){
    int32 z;
    byte i;
    iRollBuflp[bRollOffsetlp] = bSample;
    z  = (int32)(iCoeffslp[8] * iRollBuflp[(bRollOffsetlp - 8) & 0x1F]);
    for (i = 0;  i < 8;  i++){
        z += (int32)(iCoeffslp[i] * (iRollBuflp[(bRollOffsetlp - i) & 0x1F] + iRollBuflp[(bRollOffsetlp - 16 + i) & 0x1F]));
        }
    bRollOffsetlp = (bRollOffsetlp + 1) & 0x1F;
    return (word)(z >> 15);                                         // Return filter output
    }

/*************************************************************************
    Name:           CALC_iExpo()
    Parameters:     Eingabewert x
    Returns:        y = a * x + b
    Description:    expotentielle Appromaximation
 *************************************************************************/
int16 CALC_iExpo( int16 iValue ){
    byte i;
    word w;
    if(iValue >  1000) iValue =  1000;  /* Begrenzung auf Tabelle */
    if(iValue < -1000) iValue = -1000;
    w = abs(iValue);
    for(i = 0; i < nExpoTableSize; i++){/* Approximationswert suchen */
        if(w <= abExpoTable[i].wTable) break;
        }
    w = (w * abExpoTable[i].iA) / nExpoRatio + abExpoTable[i].iB;
    if(iValue >= 0){                    /* Vorzeichen bercksichtigen */
        iValue = w;                     /* I. Quadrant */
        }
    else{
        iValue = (int16)(w * -1);       /* III. Quandrant */
        }
    return iValue;
    }



/*************************************************************************
    Name:           PILOT_vMain()
    Parameters:     nothing
    Returns:        nothing
    Description:    Autopilot
 *************************************************************************/
void PILOT_vMain( cbyte cID ){
  int16 iDelta, iRollAuto, iNickAuto, iYawAuto, iEngAuto;
    //word w;

/* Roll-Achse -> Querruder */
    wRollLp   = CALC_RollLp(awAdcValue[1]);
    iDelta    = wRollLp - wRollFixLp + iDirCrtl;
    iDelta    = CALC_iExpo(iDelta);
    iRollAuto = iDelta + (iRollJoy/4);

/* Nick-Achse -> Hhenruder */
    wNickLp   = CALC_NickLp(awAdcValue[0]);
    iDelta    = wNickFixLp - wNickLp + iAltCrtl;
    iDelta    = CALC_iExpo(iDelta);
    iNickAuto = iDelta + (iNickJoy/4);

/* Yaw-Achse */
    iYawAuto  = iDirCrtl;           /* Quer auf Seitenruder gemixt */

/* Antrieb */
    iEngAuto  = iEngCrtl;
    
/* Datenausgabe an Servos */
    if((bTastFlag & 0x01) == 1){    /* Autopilot fliegt*/
        OCRTL_vSetServoCrtl(        
               iNickAuto
             , iRollAuto
             , iEngAuto
             , iYawAuto
            );
        }
    else{                           /* Der Heini mit dem Joystick */
        /* reicht seine Kunst an die Servos weiter !*/
        OCRTL_vSetServoCrtl( iNickJoy, iRollJoy, iEngJoy, iYawJoy );
        }
    }

/*************************************************************************
    Name:           PILOT_vDirCrtl()
    Parameters:     nothing
    Returns:        nothing
    Description:    Flugrichtungsberwachung/Kontrolle
 *************************************************************************/
void PILOT_vDirCrtl( cbyte cID ){
    word wDir;
    int16 i;
    /* Ist-Richtung ermitteln */
    wDir = 10; // (word)(SIO_i32GetData(FC_HEADING_DEG) / 10);  
    i = (int16)(wDir - wDirection); /* Abweichung IST - SOLL */
    if(i <= -180) i = i + 360;      /* kleineren Winkel zwischen IST und SOLL bestimmen */
    if(i >=  180) i = 360 - i;
    iDirCrtl = 0;                   /* Offsetwert zunchst := 0 */
    /* steuern nach 1. Ableitung */
    if(abs(i) > abs(iDirLastDiff)){ /* Abweichung zw. IST/SOLL ist gewachsen */
        if(i > 0){                  /* links drehen */
            iDirCrtl = -150;
            }
        if(i < 0){                  /* rechts drehen */
            iDirCrtl =  150;
            }
        }
    iDirLastDiff = i;
    }




/* Waiting */
void vDelay(dword dwTime){
    while(dwTime){
        dwTime--;        
        }
    }


/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void  main(void){
    byte bDummy = 0;     /* dummy value */
    /* Start user code. Do not edit comment generated here */
    BP_vInit();
    I2C_vInit();
    GPS_vInit();
    
    while (1){          /* cyclic call of the autopilot */
        BP_vMain(bDummy);  
        GPS_vMain(bDummy);
        PILOT_vDirCrtl(bDummy);
        PILOT_vMain(bDummy);
        vDelay(10000);  /* waiting */
        }
    /* End user code. Do not edit comment generated here */
    }


