/**************************************************************************
 *                       
 *  Name:        bosch.h  
 *  Description: Druckberechnung  
 *  Date  :      01.06.2010 
 *  Author:      
 *  Revision List:
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  01.06.10 | | Ersterstellung
  --------------------------------------------------------------------------
           |                 |
  --------------------------------------------------------------------------
 **************************************************************************/
#ifndef BOSCH_H
#define BOSCH_H

#include "cdef.h"

/* Foreign headerfiles */
//#include "stm32f10x.h"
//#include "task.h"

/***************************************************************************
* Defines und Makros fr externen Zugriff                                  *
***************************************************************************/
#define BP_nSensorAddr   0xef   /* 0xef := Read, 0xee := Write */

#define BP_nSensorRgnb   0xf4   /* Sensorregister */
#define BP_nTempValue    0x2e   /* Temperatur alle 4.5 ms */
#define BP_nBaroValue    0x34   /* Druck */
#define BP_nBTValue      0xf6   /* Ergebnisregister */

extern int32 iTemperature;
extern int32 iPressure;
extern int32 iDeltaTemp;

/***************************************************************************
*    Funktionsprototypen
****************************************************************************/
void BP_vInit      ( void );
void BP_vMain      ( cbyte );

#endif

/***************************************************************************
* EOF: DIN.H
****************************************************************************/
