/**************************************************************************
*                                                                        *
*  Name:        task.h                                                   *
*  Description: kooperatives Multitasking                                *
*                                                                        *
*  Date  :      20.07.2004                                               *
*  Author:       
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  11.09.08 |Dr.     | Ersterstellung
  --------------------------------------------------------------------------


**************************************************************************/
#ifndef GPS_H
#define GPS_H

#include "cdef.h"
//#include "task.h"

/**************************************************************************
 * Definitions
 **************************************************************************/
#define GPS_nCycletime    4   /* (GPS_nCycletime + 1) * 20 ms */

#define nGpsStrSize       16
#define nGpsValid         'A'
#define nGpsNotValid      'V'

#define n9600Baud         832
#define n9600Start        n9600Baud + (n9600Baud/2)

enum{
    enAltitude = 0,
    enSpeed,
    enCoarse,
    enUtc,
    enLatitude,           /* ddmm.nnnn */
    enLatiDir,            /* N, S */
    enLongitude,          /* dddmm.nnnn */
    enLongDir,            /* E, W */
    enValid
    };




#define nGpsTimeOut       100   /* max. 10s Lcke zwischen zwei GPS-Messages */ 
#define nGpsTimeOutFlag   0x01  /* Timeout-Flag */
#define nGpsValidFlag     0x02  /* GPS gltig */
#define nGpsNotSDA        0x04  /* keine Geschwindigkeit, Kurs oder Hhe */

#define mcSetTimeout()    (stFlightData.bFlag |=  nGpsTimeOutFlag)
#define mcClearTimeout()  (stFlightData.bFlag &= ~nGpsTimeOutFlag)
#define boTimeout         (stFlightData.bFlag &   nGpsTimeOutFlag)

#define mcSetValid()      (stFlightData.bFlag |=  nGpsValidFlag)
#define mcClearValid()    (stFlightData.bFlag &= ~nGpsValidFlag)
#define boValid           (stFlightData.bFlag &   nGpsValidFlag)

#define mcSetNoSDA()      (stFlightData.bFlag |=  nGpsNotSDA)
#define mcClearNoSDA()    (stFlightData.bFlag &= ~nGpsNotSDA)
#define boNoSDA           (stFlightData.bFlag &   nGpsNotSDA)


/**************************************************************************
 * Function prototypes
 **************************************************************************/
byte *  GPS_vGetPointer     ( byte );
byte    GPS_bDataStr        ( byte *, byte );
void    GPS_vInit           ( void );
void    GPS_vIsrPa3         ( void );
void    GPS_vIsrBitTime     ( void );
void    GPS_vIsrEmu         ( byte );
void    GPS_vMain           ( cbyte );

/* EOF */


#endif

