/**************************************************************************
 *                       
 *  Name:        i2c.h  
 *  Description: LED  
 *  Date  :      24.12.2006 
 *  Author:      
 *  Revision List:
  --------------------------------------------------------------------------
  Date     | Author          | Change
  --------------------------------------------------------------------------
  24.12.06 |                 | Ersterstellung
  --------------------------------------------------------------------------
           |                 |
  --------------------------------------------------------------------------
 **************************************************************************/
#ifndef I2C_H
#define I2C_H

#include "cdef.h"

/* Foreign headerfiles */
#include "c:\projekte\renesas_iar\cc_aug12\rea10_347\applilet3_src\r_cg_port.h"
#include <ior5f1016a.h>
//#include "stm32f10x.h"
//#include "task.h"

extern int16 iMx;
extern int16 iMy;
extern int16 iMz;


/***************************************************************************
* Defines und Makros fr externen Zugriff                                  *
***************************************************************************/
enum{
    enI2C_Start = 0,    /* start condition */
    enI2C_Write,        /* write + ack */
    enI2C_Read,         /* read + ack */
    enI2C_Stop,
    enI2C_Clear,        /* Operationsspeicher ist frei */
    enI2C_Ready,        /* Operation fertig */
    enI2C_Error         /* Fehler */ 
    };

typedef struct I2C_stTrx{
    byte  bCycl;        /* Einmalig := 0, sonst Zyklen */
    byte  bTime;        /* Zyklenspeicher */
    byte  bType;        /* Read/Write */
    byte  bAddr;        /* Device-Adresse */
    byte  bRgnb;        /* Register */
    byte  bSize;        /* Anzahl der Datenbytes */
    byte *pData;        /* Zeiger auf Datenpuffer */
    byte *pFlag;        /* Zeiger auf Ergebnisflag */
    }I2C_stTrx; 

//typedef I2C_pSingleCon * I2C_stSingleCon;

#define I2C_nCycletime  4   /* (LED_nCycletime + 1) * 20 ms */

#define nSingleListSize   16
#define nSingleListMask   nSingleListSize-1

#define nRepeatListSize   8
#define nRepeatListMask   nRepeatListSize-1

#define mcSDA_Lo()    P2 = _00_Pn2_OUTPUT_0       //(GPIOB_BSRR |= (dword)(Bit7 << 16)) /* LED1 on */
#define mcSDA_Hi()    P2 = _04_Pn2_OUTPUT_1       //(GPIOB_BSRR |= Bit7)                
#define mcSDA_Out()   PM2 &= ~_04_PMn2_MODE_INPUT //{GPIOB_CRL &= ~0xf0000000;GPIOB_CRL |= 0x70000000;}
#define mcSDA_In()    PM2 |=  _04_PMn2_MODE_INPUT //{GPIOB_CRL &= ~0xf0000000;GPIOB_CRL |= 0x40000000;}

#define mcSCL_Lo()    P14 = _00_Pn7_OUTPUT_0      //(GPIOB_BSRR |= (dword)(Bit6 << 16)) /* LED1 on */
#define mcSCL_Hi()    P14 = _80_Pn7_OUTPUT_1      //(GPIOB_BSRR |= Bit6)                

#define boSDA()       (P2 & 0x04)                 //(GPIOB_IDR & Bit7)                  /* Zustand SDA */



/***************************************************************************
*    Funktionsprototypen
****************************************************************************/
byte I2CCtrl          ( byte, byte, byte );
byte I2C_bTrxRequest  ( I2C_stTrx );
void I2C_vInit        ( void );
void I2C_vMain        ( cbyte );

#endif

/***************************************************************************
* EOF: DIN.H
****************************************************************************/
